HelpSystem module
--------------


Requirements
------------

* Tested with Yii 1.1.14, should work in earlier versions
* BootStrap 2 or 3
* cleditor


Quickstart
----------

Add module to your application config:

~~~php
<?php
    // ...
    'modules'=>array(
        // ...
       'helpSystem'=>array(
				'class'=>'ext.helpSystem.HelpSystemModule',
				'modules'=>array(
					'admin'=>array(
							'class'=>'ext.helpSystem.modules.admin.AdminModule',
					),
					'client'=>array(
							'class'=>'ext.helpSystem.modules.client.ClientModule',
					),
				),
				'bootstrapVersion'=>'3',// current bootstrap version
				'userRole'=>array(),//Add roles if any. eg array('admin','editor')
				'pageLayout'=>'//layout/main' // set the page layout path here

		),
    // ...
~~~

Run mysql script:
1. /helpSystem/database/1_DDL/1_helpSystem_base_script.sql
2. /helpSystem/database/4_DML/1_hlp_Language_Insert_script.sql

Finally add Help widget to your view template:

~~~php


<?php 
$this->widget(
	'application.extensions.helpSystem.modules.client.components.HelpWidget',
		array('title'=>'HELP', // help link title
		      'header'=>'Header Name',// header text on the widget
		      'wrapperClass'=>'', // the class added to the wrapper div if any
		      'linkClass'=>'primary', // class name if we wish to add any
		      'sectionId'=>3,	// section reference mandatory
		      'topicId'=>0, // If you wanted to load a specific topic in help box give its primary key
		      'headerBackGroundColor'=>'#EAE8E9' // default colour code. 
		     )
	);?>
~~~


