<?php
/**
 * AccessRules class file.
 * @author  Digital Mesh <info@digitalmesh.com>
 * @copyright Copyright &copy; Digital Mesh 2013-
 * @license http://www.opensource.org/licenses/bsd-license.php New BSD License
 * @package HelpSystem
 */

class AccessRules extends CApplicationComponent{
	/**
	 * Function returns Access rules for the user role(s) specified in the configuration.
	 * If no roles specified then access will be granted for all users
	 * @param array $actions
	 * @return $rules array
	 */
	public function getRuleArray($actions){
		
		$role = Yii::app()->getModule('helpSystem')->userRole;
		$rules = array();
		if(!empty($role) && is_array($role))
		{
			$rules = array(
						array('allow','actions'=>$actions,'roles'=>$role),
						array('deny','users'=>array('*'))
						);
		}
		else 
		{
			$rules = array(
						array('allow','users'=>array('*'))
						);
		}
		return $rules;
	}
}